package com.wyattjmiller.dicerollerapp

import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.util.Log
import android.view.View
import android.widget.Button
import android.widget.TextView

class DiceActivity : AppCompatActivity() {

    // Private member variables per the layout
    private lateinit var mDiceTextView: TextView
    private lateinit var mRollButton: Button

    // Private member variable - other
    private lateinit var mDieStatus: Die

    // The following methods are for keeping track of the Android lifecycle using Logcat
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_dice)

        mDiceTextView = findViewById(R.id.diceTextView)
        mRollButton = findViewById(R.id.rollButton)

        // I realize that you toggle visability in xml
        mDiceTextView.visibility = View.INVISIBLE
    }

    override fun onStart() {
        Log.d("LIFECYCLE", "onStart invoked!")
        super.onStart()
    }

    override fun onResume() {
        Log.d("LIFECYCLE", "onResume invoked!")
        super.onResume()
    }

    override fun onPause() {
        Log.d("LIFECYCLE", "onPause invoked!")
        super.onPause()
    }

    override fun onStop() {
        Log.d("LIFECYCLE", "onStop invoked!")
        super.onStop()
    }

    override fun onDestroy() {
        Log.d("LIFECYCLE", "onDestroy invoked!")
        super.onDestroy()
    }

    // code behind for the 'roll' button
    fun onClickDieRoll(view: View?) {
        val item: Array<SixDie> = SixDie.values()
        when (Randomizer().randomDieRoll(item)) {
            0 -> mDieStatus = SixDie.One
            1 -> mDieStatus = SixDie.Two
            2 -> mDieStatus = SixDie.Three
            3 -> mDieStatus = SixDie.Four
            4 -> mDieStatus = SixDie.Five
            5 -> mDieStatus = SixDie.Six
        }

        mDiceTextView.text = mDieStatus.toString()

        if (mDiceTextView.visibility == View.INVISIBLE) {
            mDiceTextView.visibility = View.VISIBLE
        }
    }

    fun onClickDieTenRoll(view: View?) {
        val item: Array<TenDie> = TenDie.values()
        when (Randomizer().randomDieRoll(item)) {
            0 -> mDieStatus = TenDie.One
            1 -> mDieStatus = TenDie.Two
            2 -> mDieStatus = TenDie.Three
            3 -> mDieStatus = TenDie.Four
            4 -> mDieStatus = TenDie.Five
            5 -> mDieStatus = TenDie.Six
            6 -> mDieStatus = TenDie.Seven
            7 -> mDieStatus = TenDie.Eight
            8 -> mDieStatus = TenDie.Nine
            9 -> mDieStatus = TenDie.Ten
        }

        mDiceTextView.text = mDieStatus.toString()

        if (mDiceTextView.visibility == View.INVISIBLE) {
            mDiceTextView.visibility = View.VISIBLE
        }
    }

    fun onClickDieTwentyRoll(view: View?) {
        val item: Array<TwentyDie> = TwentyDie.values()
        when (Randomizer().randomDieRoll(item)) {
            0 -> mDieStatus = TwentyDie.One
            1 -> mDieStatus = TwentyDie.Two
            2 -> mDieStatus = TwentyDie.Three
            3 -> mDieStatus = TwentyDie.Four
            4 -> mDieStatus = TwentyDie.Five
            5 -> mDieStatus = TwentyDie.Six
            6 -> mDieStatus = TwentyDie.Seven
            7 -> mDieStatus = TwentyDie.Eight
            8 -> mDieStatus = TwentyDie.Nine
            9 -> mDieStatus = TwentyDie.Ten
            10 -> mDieStatus = TwentyDie.Eleven
            11 -> mDieStatus = TwentyDie.Twelve
            12 -> mDieStatus = TwentyDie.Thirteen
            13 -> mDieStatus = TwentyDie.Fourteen
            14 -> mDieStatus = TwentyDie.Fifteen
            15 -> mDieStatus = TwentyDie.Sixteen
            16 -> mDieStatus = TwentyDie.Seventeen
            17 -> mDieStatus = TwentyDie.Eighteen
            18 -> mDieStatus = TwentyDie.Nineteen
            19 -> mDieStatus = TwentyDie.Twenty
        }

        mDiceTextView.text = mDieStatus.toString()

        if (mDiceTextView.visibility == View.INVISIBLE) {
            mDiceTextView.visibility = View.VISIBLE
        }
    }
}